#pragma once

class Room {

    public:
        Room(uint8_t top, uint8_t left, uint8_t width, uint8_t height);
        ~Room();

        bool generate(uint8_t depth);

        void repr(FILE* pFile);

    private:

        uint8_t top, left, width, height;

        bool split();

        enum {NODE, LEAF} type = LEAF;

        /*
         * There is up to 3 doors in a room.
         */
        union {
            Room* doors[3] = {0, 0, 0};
            Room* child[2];
        };

        /*
         * Add a door between two rooms.
         */
        bool addDoor(Room* target);

        /**
         * Populate the tree with doors
         */
        void addDoors();

        /**
         * Count how many rooms in the tree
         */
        int count();

        void _repr(FILE* pFile);
};
